<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.12"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>eduRayTracer: src/Mat.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eduRayTracer
   &#160;<span id="projectnumber">v_2017_2018_1</span>
   </div>
   <div id="projectbrief">An Educational Ray Tracing Software Package (by Pedro Santana, ISCTE-IUL)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.12 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_mat_8hpp_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Mat.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_mat_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * eduRayTracer - An Educational Ray Tracing Software Package</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> * Contributor(s): Pedro Santana - ISCTE-IUL (2014-2016)</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;</div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#ifndef _H_Mat_</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#define _H_Mat_</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;</div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_vec_8hpp.html">Vec.hpp</a>&quot;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;</div><div class="line"><a name="l00013"></a><span class="lineno"><a class="line" href="class_mat.html">   13</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_mat.html">Mat</a> {</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;</div><div class="line"><a name="l00018"></a><span class="lineno"><a class="line" href="class_mat.html#a81e79dbc41eec4017d02700a3e2e160baae6ef16e75f48a8dd715cc491af9dc50">   18</a></span>&#160;    <span class="keyword">enum</span> <a class="code" href="class_mat.html#a81e79dbc41eec4017d02700a3e2e160b">Init</a> { <a class="code" href="class_mat.html#a81e79dbc41eec4017d02700a3e2e160ba43a34a635de69cc32c8a2521662a713d">ONES</a>,  <a class="code" href="class_mat.html#a81e79dbc41eec4017d02700a3e2e160baae6ef16e75f48a8dd715cc491af9dc50">ZEROS</a>, <a class="code" href="class_mat.html#a81e79dbc41eec4017d02700a3e2e160ba66db4bfeb8c8fb32a2f397a965be7a21">EYE</a> };</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;</div><div class="line"><a name="l00021"></a><span class="lineno"><a class="line" href="class_mat.html#aaefe5fd9b60dd6722fde62ef17471251">   21</a></span>&#160;    <span class="keywordtype">double</span> <a class="code" href="class_mat.html#aaefe5fd9b60dd6722fde62ef17471251">data</a>[4][4];</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    <a class="code" href="class_mat.html#a7205342eec3270c1aa954f35d8af27c7">Mat</a> ();</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    <a class="code" href="class_mat.html#a7205342eec3270c1aa954f35d8af27c7">Mat</a> (<a class="code" href="class_mat.html#a81e79dbc41eec4017d02700a3e2e160b">Init</a> t);</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <a class="code" href="class_mat.html#a7205342eec3270c1aa954f35d8af27c7">Mat</a> (<span class="keyword">const</span> <a class="code" href="class_mat.html">Mat</a> &amp;m);</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    <a class="code" href="class_mat.html#a7205342eec3270c1aa954f35d8af27c7">Mat</a> (<span class="keyword">const</span> <span class="keywordtype">double</span> m[4][4]);</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    <span class="keyword">static</span> <a class="code" href="class_mat.html">Mat</a> <a class="code" href="class_mat.html#a0c3c288d54e1da52cfdc6282957518aa">LookAt</a> (<a class="code" href="class_vec.html">Vec</a> e, <a class="code" href="class_vec.html">Vec</a> a, <a class="code" href="class_vec.html">Vec</a> up);</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <span class="keyword">static</span> <a class="code" href="class_mat.html">Mat</a> <a class="code" href="class_mat.html#ae8d389f834ae11fb758070887558be4f">RotX</a>(<span class="keywordtype">double</span> _angle);</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    </div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    <span class="keyword">static</span> <a class="code" href="class_mat.html">Mat</a> <a class="code" href="class_mat.html#ad26724c51d7d57072a9a3462bf397059">RotY</a>(<span class="keywordtype">double</span> _angle);</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    <span class="keyword">static</span> <a class="code" href="class_mat.html">Mat</a> <a class="code" href="class_mat.html#a34ea7b2e8ecae17538e7acd01aa58cc4">RotZ</a>(<span class="keywordtype">double</span> _angle);</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    </div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    <span class="keyword">static</span> <a class="code" href="class_mat.html">Mat</a> <a class="code" href="class_mat.html#a859787d27737801fd4eb282c2a0f3b3d">Scale</a>(<span class="keywordtype">double</span> _sx, <span class="keywordtype">double</span> _sy, <span class="keywordtype">double</span> _sz);</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    </div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    <span class="keyword">static</span> <a class="code" href="class_mat.html">Mat</a> <a class="code" href="class_mat.html#a274248708a0553b5edaabbab255afdcb">Translate</a>(<span class="keywordtype">double</span> _tx, <span class="keywordtype">double</span> _ty, <span class="keywordtype">double</span> _tz);</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    <span class="keyword">static</span> <a class="code" href="class_mat.html">Mat</a> <a class="code" href="class_mat.html#acb41436cda0e8494d41cb888458ad791">FullPose</a>(<span class="keywordtype">double</span> yaw, <span class="keywordtype">double</span> pitch, <span class="keywordtype">double</span> roll, <span class="keywordtype">double</span> dx, <span class="keywordtype">double</span> dy, <span class="keywordtype">double</span> dz, </div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;                 <span class="keywordtype">double</span> scale_x, <span class="keywordtype">double</span> scale_y, <span class="keywordtype">double</span> scale_z);</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;    <a class="code" href="class_mat.html">Mat</a> <a class="code" href="class_mat.html#a2d0c8183b215b55d6d7d6de2cd099c23">operator=</a>(<span class="keyword">const</span> <a class="code" href="class_mat.html">Mat</a> &amp;m);</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    <a class="code" href="class_mat.html">Mat</a> <a class="code" href="class_mat.html#a16c420cd1147660064644876769f6c32">operator+</a>(<span class="keyword">const</span> <a class="code" href="class_mat.html">Mat</a> &amp;m);</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;    <a class="code" href="class_mat.html">Mat</a> <a class="code" href="class_mat.html#ac55ba72ef5aca0073b943f474a52cd00">operator*</a>(<span class="keyword">const</span> <a class="code" href="class_mat.html">Mat</a> &amp;m);</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160; </div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    <a class="code" href="class_vec.html">Vec</a> <a class="code" href="class_mat.html#ac55ba72ef5aca0073b943f474a52cd00">operator*</a>(<span class="keyword">const</span> <a class="code" href="class_vec.html">Vec</a> &amp;v);</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;    <a class="code" href="class_mat.html">Mat</a> <a class="code" href="class_mat.html#a55e6cc33fc65042a4cff351fe59ae476">transpose</a>();</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    <a class="code" href="class_mat.html">Mat</a> <a class="code" href="class_mat.html#aff86e230a7fdd2e204fc5e19dfce6b5c">invert</a>();</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_mat.html#ab44133772f822f6963924b1a6e94290a">print</a>();</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;    </div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;    </div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;};</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;<a class="code" href="class_mat.html">Mat</a> <a class="code" href="class_mat.html#ac55ba72ef5aca0073b943f474a52cd00">operator*</a>(<span class="keywordtype">double</span> c, <span class="keyword">const</span> <a class="code" href="class_mat.html">Mat</a> &amp;m);</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;<a class="code" href="class_mat.html">Mat</a> <a class="code" href="class_mat.html#ac55ba72ef5aca0073b943f474a52cd00">operator*</a>(<span class="keyword">const</span> <a class="code" href="class_mat.html">Mat</a> &amp;m, <span class="keywordtype">double</span> c);</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;<a class="code" href="class_mat.html">Mat</a> <a class="code" href="_mat_8hpp.html#a8bf328a20652ee05025d419d2c92579d">OnlyRot</a>(<span class="keyword">const</span> <a class="code" href="class_mat.html">Mat</a> &amp;m);</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="class_mat_html_a7205342eec3270c1aa954f35d8af27c7"><div class="ttname"><a href="class_mat.html#a7205342eec3270c1aa954f35d8af27c7">Mat::Mat</a></div><div class="ttdeci">Mat()</div><div class="ttdoc">A Mat constructor with all matrix elements set to 0. </div><div class="ttdef"><b>Definition:</b> Mat.cpp:8</div></div>
<div class="ttc" id="class_mat_html"><div class="ttname"><a href="class_mat.html">Mat</a></div><div class="ttdoc">A class to create and manipulate matrices. </div><div class="ttdef"><b>Definition:</b> Mat.hpp:13</div></div>
<div class="ttc" id="class_mat_html_a55e6cc33fc65042a4cff351fe59ae476"><div class="ttname"><a href="class_mat.html#a55e6cc33fc65042a4cff351fe59ae476">Mat::transpose</a></div><div class="ttdeci">Mat transpose()</div><div class="ttdoc">Returns the transpose of this matrix. </div><div class="ttdef"><b>Definition:</b> Mat.cpp:124</div></div>
<div class="ttc" id="class_mat_html_a859787d27737801fd4eb282c2a0f3b3d"><div class="ttname"><a href="class_mat.html#a859787d27737801fd4eb282c2a0f3b3d">Mat::Scale</a></div><div class="ttdeci">static Mat Scale(double _sx, double _sy, double _sz)</div><div class="ttdoc">Returns a Mat with its matrix elements initialised so as to implement a non-uniform scaling...</div><div class="ttdef"><b>Definition:</b> Mat.cpp:68</div></div>
<div class="ttc" id="class_mat_html_a81e79dbc41eec4017d02700a3e2e160ba66db4bfeb8c8fb32a2f397a965be7a21"><div class="ttname"><a href="class_mat.html#a81e79dbc41eec4017d02700a3e2e160ba66db4bfeb8c8fb32a2f397a965be7a21">Mat::EYE</a></div><div class="ttdef"><b>Definition:</b> Mat.hpp:18</div></div>
<div class="ttc" id="class_mat_html_ad26724c51d7d57072a9a3462bf397059"><div class="ttname"><a href="class_mat.html#ad26724c51d7d57072a9a3462bf397059">Mat::RotY</a></div><div class="ttdeci">static Mat RotY(double _angle)</div><div class="ttdoc">Returns a Mat with its matrix elements initialised so as to implement a rotation around the y-axis...</div><div class="ttdef"><b>Definition:</b> Mat.cpp:46</div></div>
<div class="ttc" id="class_mat_html_acb41436cda0e8494d41cb888458ad791"><div class="ttname"><a href="class_mat.html#acb41436cda0e8494d41cb888458ad791">Mat::FullPose</a></div><div class="ttdeci">static Mat FullPose(double yaw, double pitch, double roll, double dx, double dy, double dz, double scale_x, double scale_y, double scale_z)</div><div class="ttdef"><b>Definition:</b> Mat.cpp:112</div></div>
<div class="ttc" id="class_mat_html_a16c420cd1147660064644876769f6c32"><div class="ttname"><a href="class_mat.html#a16c420cd1147660064644876769f6c32">Mat::operator+</a></div><div class="ttdeci">Mat operator+(const Mat &amp;m)</div><div class="ttdoc">Returns a matrix resulting from adding a given matrix to this matrix. </div><div class="ttdef"><b>Definition:</b> Mat.cpp:142</div></div>
<div class="ttc" id="class_mat_html_a81e79dbc41eec4017d02700a3e2e160baae6ef16e75f48a8dd715cc491af9dc50"><div class="ttname"><a href="class_mat.html#a81e79dbc41eec4017d02700a3e2e160baae6ef16e75f48a8dd715cc491af9dc50">Mat::ZEROS</a></div><div class="ttdef"><b>Definition:</b> Mat.hpp:18</div></div>
<div class="ttc" id="class_mat_html_a2d0c8183b215b55d6d7d6de2cd099c23"><div class="ttname"><a href="class_mat.html#a2d0c8183b215b55d6d7d6de2cd099c23">Mat::operator=</a></div><div class="ttdeci">Mat operator=(const Mat &amp;m)</div><div class="ttdoc">Copies the contents of a given matrix to this matrix (assignment operator) </div><div class="ttdef"><b>Definition:</b> Mat.cpp:133</div></div>
<div class="ttc" id="class_mat_html_a0c3c288d54e1da52cfdc6282957518aa"><div class="ttname"><a href="class_mat.html#a0c3c288d54e1da52cfdc6282957518aa">Mat::LookAt</a></div><div class="ttdeci">static Mat LookAt(Vec e, Vec a, Vec up)</div><div class="ttdoc">A Mat constructor with matrix elements initialised according to eye-gaze-up convention. </div><div class="ttdef"><b>Definition:</b> Mat.cpp:100</div></div>
<div class="ttc" id="class_mat_html_a274248708a0553b5edaabbab255afdcb"><div class="ttname"><a href="class_mat.html#a274248708a0553b5edaabbab255afdcb">Mat::Translate</a></div><div class="ttdeci">static Mat Translate(double _tx, double _ty, double _tz)</div><div class="ttdoc">Returns a Mat with its matrix elements initialised so as to implement a translation. </div><div class="ttdef"><b>Definition:</b> Mat.cpp:78</div></div>
<div class="ttc" id="class_vec_html"><div class="ttname"><a href="class_vec.html">Vec</a></div><div class="ttdoc">A class to create and manipulate 3D vectors. These can be used to store positions, normals, and RGB triplets. </div><div class="ttdef"><b>Definition:</b> Vec.hpp:16</div></div>
<div class="ttc" id="class_mat_html_ab44133772f822f6963924b1a6e94290a"><div class="ttname"><a href="class_mat.html#ab44133772f822f6963924b1a6e94290a">Mat::print</a></div><div class="ttdeci">void print()</div><div class="ttdoc">Sends to the std::out information regarding this matrix. </div><div class="ttdef"><b>Definition:</b> Mat.cpp:174</div></div>
<div class="ttc" id="class_mat_html_ac55ba72ef5aca0073b943f474a52cd00"><div class="ttname"><a href="class_mat.html#ac55ba72ef5aca0073b943f474a52cd00">Mat::operator*</a></div><div class="ttdeci">Mat operator*(const Mat &amp;m)</div><div class="ttdoc">Returns a matrix resulting from multiplying this matrix to another given matrix (proper matrix dimens...</div><div class="ttdef"><b>Definition:</b> Mat.cpp:150</div></div>
<div class="ttc" id="class_mat_html_a81e79dbc41eec4017d02700a3e2e160b"><div class="ttname"><a href="class_mat.html#a81e79dbc41eec4017d02700a3e2e160b">Mat::Init</a></div><div class="ttdeci">Init</div><div class="ttdoc">labels for creating patterned matrices </div><div class="ttdef"><b>Definition:</b> Mat.hpp:18</div></div>
<div class="ttc" id="class_mat_html_ae8d389f834ae11fb758070887558be4f"><div class="ttname"><a href="class_mat.html#ae8d389f834ae11fb758070887558be4f">Mat::RotX</a></div><div class="ttdeci">static Mat RotX(double _angle)</div><div class="ttdoc">Returns a Mat with its matrix elements initialised so as to implement a rotation around the x-axis...</div><div class="ttdef"><b>Definition:</b> Mat.cpp:35</div></div>
<div class="ttc" id="_vec_8hpp_html"><div class="ttname"><a href="_vec_8hpp.html">Vec.hpp</a></div></div>
<div class="ttc" id="_mat_8hpp_html_a8bf328a20652ee05025d419d2c92579d"><div class="ttname"><a href="_mat_8hpp.html#a8bf328a20652ee05025d419d2c92579d">OnlyRot</a></div><div class="ttdeci">Mat OnlyRot(const Mat &amp;m)</div><div class="ttdef"><b>Definition:</b> Mat.cpp:205</div></div>
<div class="ttc" id="class_mat_html_a81e79dbc41eec4017d02700a3e2e160ba43a34a635de69cc32c8a2521662a713d"><div class="ttname"><a href="class_mat.html#a81e79dbc41eec4017d02700a3e2e160ba43a34a635de69cc32c8a2521662a713d">Mat::ONES</a></div><div class="ttdef"><b>Definition:</b> Mat.hpp:18</div></div>
<div class="ttc" id="class_mat_html_a34ea7b2e8ecae17538e7acd01aa58cc4"><div class="ttname"><a href="class_mat.html#a34ea7b2e8ecae17538e7acd01aa58cc4">Mat::RotZ</a></div><div class="ttdeci">static Mat RotZ(double _angle)</div><div class="ttdoc">Returns a Mat with its matrix elements initialised so as to implement a rotation around the z-axis...</div><div class="ttdef"><b>Definition:</b> Mat.cpp:57</div></div>
<div class="ttc" id="class_mat_html_aaefe5fd9b60dd6722fde62ef17471251"><div class="ttname"><a href="class_mat.html#aaefe5fd9b60dd6722fde62ef17471251">Mat::data</a></div><div class="ttdeci">double data[4][4]</div><div class="ttdoc">array containing the matrix data </div><div class="ttdef"><b>Definition:</b> Mat.hpp:21</div></div>
<div class="ttc" id="class_mat_html_aff86e230a7fdd2e204fc5e19dfce6b5c"><div class="ttname"><a href="class_mat.html#aff86e230a7fdd2e204fc5e19dfce6b5c">Mat::invert</a></div><div class="ttdeci">Mat invert()</div><div class="ttdoc">Returns the inverted version of this matrix. </div><div class="ttdef"><b>Definition:</b> Mat.cpp:195</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="_mat_8hpp.html">Mat.hpp</a></li>
    <li class="footer">Generated on Fri Sep 15 2017 15:54:23 for eduRayTracer by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.12 </li>
  </ul>
</div>
</body>
</html>
